Loading...
Searching...
No Matches
Opm::OilPvtThermal< Scalar > Class Template Reference

This class implements temperature dependence of the PVT properties of oil. More...

`#include <OilPvtThermal.hpp>`

## Public Types

using | TabulatedOneDFunction = Tabulated1DFunction<Scalar>
using | IsothermalPvt = OilPvtMultiplexer<Scalar, false>

## Public Member Functions

OilPvtThermal (IsothermalPvt *isothermalPvt, const std::vector< TabulatedOneDFunction > &oilvisctCurves, const std::vector< Scalar > &viscrefPress, const std::vector< Scalar > &viscrefRs, const std::vector< Scalar > &viscRef, const std::vector< Scalar > &oildentRefTemp, const std::vector< Scalar > &oildentCT1, const std::vector< Scalar > &oildentCT2, const std::vector< Scalar > &oilJTRefPres, const std::vector< Scalar > &oilJTC, const std::vector< TabulatedOneDFunction > &internalEnergyCurves, bool enableThermalDensity, bool enableJouleThomson, bool enableThermalViscosity, bool enableInternalEnergy)

| OilPvtThermal (const OilPvtThermal &data)
void | setNumRegions (std::size_t numRegions)
| Set the number of PVT-regions considered by this object.
void | setVapPars (const Scalar par1, const Scalar par2)
void | initEnd ()
| Finish initializing the thermal part of the oil phase PVT properties.
bool | enableThermalDensity () const
| Returns true iff the density of the oil phase is temperature dependent.
bool | enableJouleThomson () const
| Returns true iff Joule-Thomson effect for the oil phase is active.
bool | enableThermalViscosity () const
| Returns true iff the viscosity of the oil phase is temperature dependent.
std::size_t | numRegions () const
template<class Evaluation>
Evaluation | internalEnergy (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &Rs) const
| Returns the specific internal energy [J/kg] of oil given a set of parameters.
template<class Evaluation>
Evaluation | viscosity (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &Rs) const
| Returns the dynamic viscosity [Pa s] of the fluid phase given a set of parameters.
template<class Evaluation>
Evaluation | saturatedViscosity (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure) const
| Returns the dynamic viscosity [Pa s] of the fluid phase given a set of parameters.
template<class Evaluation>
Evaluation | inverseFormationVolumeFactor (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &Rs) const
| Returns the formation volume factor [-] of the fluid phase.
template<class FluidState, class LhsEval = typename FluidState::Scalar>
std::pair< LhsEval, LhsEval > | inverseFormationVolumeFactorAndViscosity (const FluidState &fluidState, unsigned regionIdx)
| Returns the formation volume factor [-] and viscosity [Pa s] of the fluid phase.
template<class Evaluation>
Evaluation | saturatedInverseFormationVolumeFactor (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure) const
| Returns the formation volume factor [-] of gas-saturated oil phase.
template<class Evaluation>
Evaluation | saturatedGasDissolutionFactor (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure) const
| Returns the gas dissolution factor [m^3/m^3] of the oil phase.
template<class Evaluation>
Evaluation | saturatedGasDissolutionFactor (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &oilSaturation, const Evaluation &maxOilSaturation) const
| Returns the gas dissolution factor [m^3/m^3] of the oil phase.
template<class Evaluation>
Evaluation | saturationPressure (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure) const
| Returns the saturation pressure of the oil phase [Pa].
template<class Evaluation>
Evaluation | diffusionCoefficient (const Evaluation &temperature, const Evaluation &pressure, unsigned compIdx) const
const IsothermalPvt * | isoThermalPvt () const
Scalar | oilReferenceDensity (unsigned regionIdx) const
Scalar | hVap (unsigned regionIdx) const
const std::vector< TabulatedOneDFunction > & | oilvisctCurves () const
const std::vector< Scalar > & | viscrefPress () const
const std::vector< Scalar > & | viscrefRs () const
const std::vector< Scalar > & | viscRef () const
const std::vector< Scalar > & | oildentRefTemp () const
const std::vector< Scalar > & | oildentCT1 () const
const std::vector< Scalar > & | oildentCT2 () const
const std::vector< TabulatedOneDFunction > & | internalEnergyCurves () const
bool | enableInternalEnergy () const
const std::vector< Scalar > & | oilJTRefPres () const
const std::vector< Scalar > & | oilJTC () const
bool | operator== (const OilPvtThermal< Scalar > &data) const
OilPvtThermal< Scalar > & | operator= (const OilPvtThermal< Scalar > &data)

## Detailed Description

template<class Scalar>
class Opm::OilPvtThermal< Scalar >

This class implements temperature dependence of the PVT properties of oil.

Note that this only implements the temperature part, i.e., it requires the isothermal properties as input.

## Member Function Documentation

## saturatedGasDissolutionFactor() [1/2]

template<class Scalar>
template<class Evaluation>

Evaluation Opm::OilPvtThermal< Scalar >::saturatedGasDissolutionFactor | ( | unsigned | regionIdx,
|  | const Evaluation & | temperature,
|  | const Evaluation & | pressure ) const

inline

Returns the gas dissolution factor [m^3/m^3] of the oil phase.

This method implements temperature dependence and requires the isothermal gas dissolution factor for gas saturated oil and temperature as inputs. Currently it is just a dummy method which passes through the isothermal gas dissolution factor.

## saturatedGasDissolutionFactor() [2/2]

template<class Scalar>
template<class Evaluation>

Evaluation Opm::OilPvtThermal< Scalar >::saturatedGasDissolutionFactor | ( | unsigned | regionIdx,
|  | const Evaluation & | temperature,
|  | const Evaluation & | pressure,
|  | const Evaluation & | oilSaturation,
|  | const Evaluation & | maxOilSaturation ) const

inline

Returns the gas dissolution factor [m^3/m^3] of the oil phase.

This method implements temperature dependence and requires the isothermal gas dissolution factor for gas saturated oil and temperature as inputs. Currently it is just a dummy method which passes through the isothermal gas dissolution factor.

## saturationPressure()

template<class Scalar>
template<class Evaluation>

Evaluation Opm::OilPvtThermal< Scalar >::saturationPressure | ( | unsigned | regionIdx,
|  | const Evaluation & | temperature,
|  | const Evaluation & | pressure ) const

inline

Returns the saturation pressure of the oil phase [Pa].

This method implements temperature dependence and requires isothermal satuation pressure and temperature as inputs. Currently it is just a dummy method which passes through the isothermal saturation pressure.

The documentation for this class was generated from the following files:

- opm/material/fluidsystems/blackoilpvt/OilPvtThermal.hpp
- opm/material/fluidsystems/blackoilpvt/OilPvtThermal.cpp